/// <reference types="node" />
import { Idl, InstructionCoder } from "@project-serum/anchor";
export declare class WormholeInstructionCoder implements InstructionCoder {
    constructor(_: Idl);
    encode(ixName: string, ix: any): Buffer;
    encodeState(_ixName: string, _ix: any): Buffer;
}
/** Solitaire enum of existing the Core Bridge's instructions.
 *
 * https://github.com/certusone/wormhole/blob/dev.v2/solana/bridge/program/src/lib.rs#L92
 */
export declare enum WormholeInstruction {
    Initialize = 0,
    PostMessage = 1,
    PostVAA = 2,
    SetFees = 3,
    TransferFees = 4,
    UpgradeContract = 5,
    UpgradeGuardianSet = 6,
    VerifySignatures = 7,
    PostMessageUnreliable = 8
}
